import{s as we,f as J,o as _e}from"../chunks/scheduler.37c15a92.js";import{S as be,i as ye,g as a,s,r as K,A as $e,h as o,f as i,c as n,j as de,u as Q,x as r,k as u,y as Te,a as l,v as X,d as Y,t as Z,w as tt,m as Le,n as xe}from"../chunks/index.7cb9c9b8.js";import{T as Me}from"../chunks/Tip.d10b3fc9.js";import{H as Bt,E as He}from"../chunks/EditOnGithub.858acfec.js";function Pe(it){let g;return{c(){g=Le("Now that we learned the RL framework, how do we solve the RL problem?")},l(c){g=xe(c,"Now that we learned the RL framework, how do we solve the RL problem?")},m(c,_){l(c,g,_)},d(c){c&&i(g)}}}function Ce(it){let g,c,_,lt,b,st,p,nt,y,Ft="In other words, how do we build an RL agent that can <strong>select the actions that maximize its expected cumulative reward?</strong>",at,$,ot,T,qt="The Policy <strong>π</strong> is the <strong>brain of our Agent</strong>, it’s the function that tells us what <strong>action to take given the state we are in.</strong> So it <strong>defines the agent’s behavior</strong> at a given time.",rt,L,St='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/policy_1.jpg" alt="Policy"/> <figcaption>Think of policy as the brain of our agent, the function that will tell us the action to take given a state</figcaption>',ut,x,Dt="This Policy <strong>is the function we want to learn</strong>, our goal is to find the optimal policy π*, the policy that <strong>maximizes expected return</strong> when the agent acts according to it. We find this π* <strong>through training.</strong>",gt,M,Nt="There are two approaches to train our agent to find this optimal policy π*:",ct,H,Wt="<li><strong>Directly,</strong> by teaching the agent to learn which <strong>action to take,</strong> given the current state: <strong>Policy-Based Methods.</strong></li> <li>Indirectly, <strong>teach the agent to learn which state is more valuable</strong> and then take the action that <strong>leads to the more valuable states</strong>: Value-Based Methods.</li>",pt,P,ft,C,Ot="In Policy-Based methods, <strong>we learn a policy function directly.</strong>",mt,I,Jt="This function will define a mapping from each state to the best corresponding action. Alternatively, it could define <strong>a probability distribution over the set of possible actions at that state.</strong>",ht,R,Kt='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/policy_2.jpg" alt="Policy"/> <figcaption>As we can see here, the policy (deterministic) <b>directly indicates the action to take for each step.</b></figcaption>',vt,k,Qt="We have two types of policies:",dt,G,Xt="<li><em>Deterministic</em>: a policy at a given state <strong>will always return the same action.</strong></li>",wt,j,Yt='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/policy_3.jpg" alt="Policy"/> <figcaption>action = policy(state)</figcaption>',_t,f,Zt,bt,E,te="<li><em>Stochastic</em>: outputs <strong>a probability distribution over actions.</strong></li>",yt,U,ee='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/policy_5.jpg" alt="Policy"/> <figcaption>policy(actions | state) = probability distribution over the set of actions given the current state</figcaption>',$t,V,ie='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/policy-based.png" alt="Policy Based"/> <figcaption>Given an initial state, our stochastic policy will output probability distributions over the possible actions at that state.</figcaption>',Tt,z,le="If we recap:",Lt,m,se,xt,h,ne,Mt,A,Ht,B,ae="In value-based methods, instead of learning a policy function, we <strong>learn a value function</strong> that maps a state to the expected value <strong>of being at that state.</strong>",Pt,F,oe="The value of a state is the <strong>expected discounted return</strong> the agent can get if it <strong>starts in that state, and then acts according to our policy.</strong>",Ct,q,re="“Act according to our policy” just means that our policy is <strong>“going to the state with the highest value”.</strong>",It,v,ue,Rt,S,ge="Here we see that our value function <strong>defined values for each possible state.</strong>",kt,D,ce='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/value_2.jpg" alt="Value based RL"/> <figcaption>Thanks to our value function, at each step our policy will select the state with the biggest value defined by the value function: -7, then -6, then -5 (and so on) to attain the goal.</figcaption>',Gt,N,pe="Thanks to our value function, at each step our policy will select the state with the biggest value defined by the value function: -7, then -6, then -5 (and so on) to attain the goal.",jt,W,fe="If we recap:",Et,d,me,Ut,w,he,Vt,O,zt,et,At;return b=new Bt({props:{title:"Two main approaches for solving RL problems",local:"two-methods",headingTag:"h1"}}),p=new Me({props:{$$slots:{default:[Pe]},$$scope:{ctx:it}}}),$=new Bt({props:{title:"The Policy π: the agent’s brain",local:"policy",headingTag:"h2"}}),P=new Bt({props:{title:"Policy-Based Methods",local:"policy-based",headingTag:"h2"}}),A=new Bt({props:{title:"Value-based methods",local:"value-based",headingTag:"h2"}}),O=new He({props:{source:"https://github.com/huggingface/deep-rl-class/blob/main/units/en/unit1/two-methods.mdx"}}),{c(){g=a("meta"),c=s(),_=a("p"),lt=s(),K(b.$$.fragment),st=s(),K(p.$$.fragment),nt=s(),y=a("p"),y.innerHTML=Ft,at=s(),K($.$$.fragment),ot=s(),T=a("p"),T.innerHTML=qt,rt=s(),L=a("figure"),L.innerHTML=St,ut=s(),x=a("p"),x.innerHTML=Dt,gt=s(),M=a("p"),M.textContent=Nt,ct=s(),H=a("ul"),H.innerHTML=Wt,pt=s(),K(P.$$.fragment),ft=s(),C=a("p"),C.innerHTML=Ot,mt=s(),I=a("p"),I.innerHTML=Jt,ht=s(),R=a("figure"),R.innerHTML=Kt,vt=s(),k=a("p"),k.textContent=Qt,dt=s(),G=a("ul"),G.innerHTML=Xt,wt=s(),j=a("figure"),j.innerHTML=Yt,_t=s(),f=a("img"),bt=s(),E=a("ul"),E.innerHTML=te,yt=s(),U=a("figure"),U.innerHTML=ee,$t=s(),V=a("figure"),V.innerHTML=ie,Tt=s(),z=a("p"),z.textContent=le,Lt=s(),m=a("img"),xt=s(),h=a("img"),Mt=s(),K(A.$$.fragment),Ht=s(),B=a("p"),B.innerHTML=ae,Pt=s(),F=a("p"),F.innerHTML=oe,Ct=s(),q=a("p"),q.innerHTML=re,It=s(),v=a("img"),Rt=s(),S=a("p"),S.innerHTML=ge,kt=s(),D=a("figure"),D.innerHTML=ce,Gt=s(),N=a("p"),N.textContent=pe,jt=s(),W=a("p"),W.textContent=fe,Et=s(),d=a("img"),Ut=s(),w=a("img"),Vt=s(),K(O.$$.fragment),zt=s(),et=a("p"),this.h()},l(t){const e=$e("svelte-u9bgzb",document.head);g=o(e,"META",{name:!0,content:!0}),e.forEach(i),c=n(t),_=o(t,"P",{}),de(_).forEach(i),lt=n(t),Q(b.$$.fragment,t),st=n(t),Q(p.$$.fragment,t),nt=n(t),y=o(t,"P",{"data-svelte-h":!0}),r(y)!=="svelte-1poqzkt"&&(y.innerHTML=Ft),at=n(t),Q($.$$.fragment,t),ot=n(t),T=o(t,"P",{"data-svelte-h":!0}),r(T)!=="svelte-1sury9w"&&(T.innerHTML=qt),rt=n(t),L=o(t,"FIGURE",{"data-svelte-h":!0}),r(L)!=="svelte-wr9ae2"&&(L.innerHTML=St),ut=n(t),x=o(t,"P",{"data-svelte-h":!0}),r(x)!=="svelte-g271gb"&&(x.innerHTML=Dt),gt=n(t),M=o(t,"P",{"data-svelte-h":!0}),r(M)!=="svelte-7rf0mi"&&(M.textContent=Nt),ct=n(t),H=o(t,"UL",{"data-svelte-h":!0}),r(H)!=="svelte-1dvt8p7"&&(H.innerHTML=Wt),pt=n(t),Q(P.$$.fragment,t),ft=n(t),C=o(t,"P",{"data-svelte-h":!0}),r(C)!=="svelte-4zn9b3"&&(C.innerHTML=Ot),mt=n(t),I=o(t,"P",{"data-svelte-h":!0}),r(I)!=="svelte-oozyd0"&&(I.innerHTML=Jt),ht=n(t),R=o(t,"FIGURE",{"data-svelte-h":!0}),r(R)!=="svelte-1m4eqa9"&&(R.innerHTML=Kt),vt=n(t),k=o(t,"P",{"data-svelte-h":!0}),r(k)!=="svelte-119iy72"&&(k.textContent=Qt),dt=n(t),G=o(t,"UL",{"data-svelte-h":!0}),r(G)!=="svelte-h86bbg"&&(G.innerHTML=Xt),wt=n(t),j=o(t,"FIGURE",{"data-svelte-h":!0}),r(j)!=="svelte-15macrs"&&(j.innerHTML=Yt),_t=n(t),f=o(t,"IMG",{src:!0,alt:!0,width:!0}),bt=n(t),E=o(t,"UL",{"data-svelte-h":!0}),r(E)!=="svelte-1q48317"&&(E.innerHTML=te),yt=n(t),U=o(t,"FIGURE",{"data-svelte-h":!0}),r(U)!=="svelte-dxiuol"&&(U.innerHTML=ee),$t=n(t),V=o(t,"FIGURE",{"data-svelte-h":!0}),r(V)!=="svelte-120mc27"&&(V.innerHTML=ie),Tt=n(t),z=o(t,"P",{"data-svelte-h":!0}),r(z)!=="svelte-1uwte4"&&(z.textContent=le),Lt=n(t),m=o(t,"IMG",{src:!0,alt:!0,width:!0}),xt=n(t),h=o(t,"IMG",{src:!0,alt:!0,width:!0}),Mt=n(t),Q(A.$$.fragment,t),Ht=n(t),B=o(t,"P",{"data-svelte-h":!0}),r(B)!=="svelte-v48g1w"&&(B.innerHTML=ae),Pt=n(t),F=o(t,"P",{"data-svelte-h":!0}),r(F)!=="svelte-1wvuk6o"&&(F.innerHTML=oe),Ct=n(t),q=o(t,"P",{"data-svelte-h":!0}),r(q)!=="svelte-1xwf190"&&(q.innerHTML=re),It=n(t),v=o(t,"IMG",{src:!0,alt:!0,width:!0}),Rt=n(t),S=o(t,"P",{"data-svelte-h":!0}),r(S)!=="svelte-19buk39"&&(S.innerHTML=ge),kt=n(t),D=o(t,"FIGURE",{"data-svelte-h":!0}),r(D)!=="svelte-hm65hv"&&(D.innerHTML=ce),Gt=n(t),N=o(t,"P",{"data-svelte-h":!0}),r(N)!=="svelte-4bnt7i"&&(N.textContent=pe),jt=n(t),W=o(t,"P",{"data-svelte-h":!0}),r(W)!=="svelte-1uwte4"&&(W.textContent=fe),Et=n(t),d=o(t,"IMG",{src:!0,alt:!0,width:!0}),Ut=n(t),w=o(t,"IMG",{src:!0,alt:!0,width:!0}),Vt=n(t),Q(O.$$.fragment,t),zt=n(t),et=o(t,"P",{}),de(et).forEach(i),this.h()},h(){u(g,"name","hf:doc:metadata"),u(g,"content",Ie),J(f.src,Zt="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/policy_4.jpg")||u(f,"src",Zt),u(f,"alt","Policy"),u(f,"width","100%"),J(m.src,se="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/pbm_1.jpg")||u(m,"src",se),u(m,"alt","Pbm recap"),u(m,"width","100%"),J(h.src,ne="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/pbm_2.jpg")||u(h,"src",ne),u(h,"alt","Pbm recap"),u(h,"width","100%"),J(v.src,ue="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/value_1.jpg")||u(v,"src",ue),u(v,"alt","Value based RL"),u(v,"width","100%"),J(d.src,me="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/vbm_1.jpg")||u(d,"src",me),u(d,"alt","Vbm recap"),u(d,"width","100%"),J(w.src,he="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/vbm_2.jpg")||u(w,"src",he),u(w,"alt","Vbm recap"),u(w,"width","100%")},m(t,e){Te(document.head,g),l(t,c,e),l(t,_,e),l(t,lt,e),X(b,t,e),l(t,st,e),X(p,t,e),l(t,nt,e),l(t,y,e),l(t,at,e),X($,t,e),l(t,ot,e),l(t,T,e),l(t,rt,e),l(t,L,e),l(t,ut,e),l(t,x,e),l(t,gt,e),l(t,M,e),l(t,ct,e),l(t,H,e),l(t,pt,e),X(P,t,e),l(t,ft,e),l(t,C,e),l(t,mt,e),l(t,I,e),l(t,ht,e),l(t,R,e),l(t,vt,e),l(t,k,e),l(t,dt,e),l(t,G,e),l(t,wt,e),l(t,j,e),l(t,_t,e),l(t,f,e),l(t,bt,e),l(t,E,e),l(t,yt,e),l(t,U,e),l(t,$t,e),l(t,V,e),l(t,Tt,e),l(t,z,e),l(t,Lt,e),l(t,m,e),l(t,xt,e),l(t,h,e),l(t,Mt,e),X(A,t,e),l(t,Ht,e),l(t,B,e),l(t,Pt,e),l(t,F,e),l(t,Ct,e),l(t,q,e),l(t,It,e),l(t,v,e),l(t,Rt,e),l(t,S,e),l(t,kt,e),l(t,D,e),l(t,Gt,e),l(t,N,e),l(t,jt,e),l(t,W,e),l(t,Et,e),l(t,d,e),l(t,Ut,e),l(t,w,e),l(t,Vt,e),X(O,t,e),l(t,zt,e),l(t,et,e),At=!0},p(t,[e]){const ve={};e&2&&(ve.$$scope={dirty:e,ctx:t}),p.$set(ve)},i(t){At||(Y(b.$$.fragment,t),Y(p.$$.fragment,t),Y($.$$.fragment,t),Y(P.$$.fragment,t),Y(A.$$.fragment,t),Y(O.$$.fragment,t),At=!0)},o(t){Z(b.$$.fragment,t),Z(p.$$.fragment,t),Z($.$$.fragment,t),Z(P.$$.fragment,t),Z(A.$$.fragment,t),Z(O.$$.fragment,t),At=!1},d(t){t&&(i(c),i(_),i(lt),i(st),i(nt),i(y),i(at),i(ot),i(T),i(rt),i(L),i(ut),i(x),i(gt),i(M),i(ct),i(H),i(pt),i(ft),i(C),i(mt),i(I),i(ht),i(R),i(vt),i(k),i(dt),i(G),i(wt),i(j),i(_t),i(f),i(bt),i(E),i(yt),i(U),i($t),i(V),i(Tt),i(z),i(Lt),i(m),i(xt),i(h),i(Mt),i(Ht),i(B),i(Pt),i(F),i(Ct),i(q),i(It),i(v),i(Rt),i(S),i(kt),i(D),i(Gt),i(N),i(jt),i(W),i(Et),i(d),i(Ut),i(w),i(Vt),i(zt),i(et)),i(g),tt(b,t),tt(p,t),tt($,t),tt(P,t),tt(A,t),tt(O,t)}}}const Ie='{"title":"Two main approaches for solving RL problems","local":"two-methods","sections":[{"title":"The Policy π: the agent’s brain","local":"policy","sections":[],"depth":2},{"title":"Policy-Based Methods","local":"policy-based","sections":[],"depth":2},{"title":"Value-based methods","local":"value-based","sections":[],"depth":2}],"depth":1}';function Re(it){return _e(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ue extends be{constructor(g){super(),ye(this,g,Re,Ce,we,{})}}export{Ue as component};
